<h1>Task 1</h1>

[Worksheet 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1) | [Task 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%202) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%203) | [Task 4](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%204)

<p>This solution to task 1 implements a simplified version of C++'s string class. It includes dynamic memory management and a simple interface to view the results. As this task sets the foundations for the rest of the worksheet it will be discussed and demonstrated in greater detail.</p>
<br/>
<h3>Step 1 - Class Design</h3>
<p>The class design is fairly straightforward and follows standard c++ conventions, including constructors, assignment operators, destructors and functions. According to standard C++ practices this is a header file as it initialises the main class used.</p>
<h5>Constructors</h5>
Three types of constructor are used here; <br/>
1. Default to initialize the empty string.<br/>
2. Parameterized to allocate memory and copy c-style string.<br/>
3. Copy to create a shallow copy, sharing memory with the original.
![Constructors](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task1_constructors.png "Constructors")
<br/>
<h5>Operators</h5>
The assignment operators ensure that the string is properly copied.<br/>
![Assignment Operators](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task1_assignment_opperators.png "Operators")
<br/>
<h5>Destructor</h5>
The destructor is not used for task 1 but will be used to handle freeing resources in further tasks. <br/>
![Destructor](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task1_destructor.png "Destructor")
<br/>
<h5>Functions</h5>
The functions in this class are relatively simple. A "get" to return the character at index "i", a "set" to set the character at index "i" and a print functions, which hopefully explains itself. <br/>
![Member Functions](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task1_functions.png "Member Functions")
<br/><br/>
These are the key aspect of the "my_string" class, which is used for the rest of the worksheet. These aspects will change through other tasks and will be referenced multiple times.
<br/>
<h3>Step 2 - Memory Management</h3> 
The string is managed through dynamic memory using "new" and "delete". "new" has already been seen in the Parameterized constructor above. Delete is included within the private section of the class nested within an if statement in order to only be accessed when necassary from within the class: <br/>
![delete](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task1_delete.png "Delete")<br/>
The other aspect of memory management is through the use of shallow copies. A shallow copy copies the references(pointers) to the resources of the original object, this ensures that the original and the copy both share the same resource in memory.<br/>
<h3>Testing</h3>
Any programs need testing and, in this case, it is rather simple as it was provided within the worksheet. When compiled using "clang++" and ran through the terminal the program gives the result below. <br/>
![test](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task1_testing.png "testing") <br/>
<br/><br/>
Current page - Task 1<br/>
[Worksheet 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1) | [Task 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%202) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%203) | [Task 4](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%204)



