<h1>Task 4</h1>
[Worksheet 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1) | [Task 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%201) | [Task 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%202) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%203)
<br/>

Task 1 is easily the largest task as it involves tackling the referencing counting from another angle, using a template rather than building it into the my_string class. This gives a large amount of utility as a more general method can be used for reference handling of any type of object. This task was handled in two key stages, first creating and testing the new template using a more basic "point" class, followed by applying the template class to our "my_string" class to check full functionality.
<br/>
<h2>Stage 1 - Template<h2/>
Generating a template class with inbuilt reference counting enables easier application of reference counting to a wider array of objects rather that just the "my_string" class.
<h3>Step 1 - Defining the class<h3/>
The template class "temp_ref" is designed to manage any object of type "temp" with a reference count that will track the instances of "temp_ref" that share the same object. It includes a pointer to type "temp", the target of the reference counter, and a pointer to a integer variable that tracks how many objects are referencing the "obj".<br/>
![Template definition](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_definition.png "Template definition")<br/>
<h3>Step 2 - Constructors and operators<h3/>
The Constructors are relatively easy here as they function the same as in previous tasks, ensuring that when a "temp_ref" object is counted the reference counter gets incremented. The Assignment operator is similarly easy, with it being a reproduction of the earlier methods.<br/>
<h3>Step 3 - More operators</h3>
There are two further operators needed for proper functionality, deference and access. The deference operator allows access to the object "temp" that is being managed:<br/>
![Deference operator](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_deference.png "Deference operator")<br/>
The access operator allows pointer style access to "temp" whilst inside "temp_ref":<br/>
![Access operator](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_access.png "Access operator")<br/>
<h3>Step 3 - Point class</h3>
A basic point class "point" is created in "test_point.hpp" for testing and refining the template class:<br/>
![Point class](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_point_class.png "Point class")<br/>
The class is very simple and include just enough information for proper testing.
<h3>Step 4 - Point testing</h3>
The testing requires a basic execution program to run, this assigns the point class to the template:<br/>
![Point main](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_point_main.png "Point main")<br/>

When ran this gives the following result:<br/>
![Test Point](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_test_point.png "Test point")<br/>

This test show that the reference count of "point" is increment when "p2" is created copying "p1", when "p2" goes out of scope the count drops back down to 1, a clear indication for the behaviour required.

<h2>Stage 2 - Applying to "my_string"</h2>
Once the "point" class has been used to develop and test the template class, it is necassary to integrate the template with the "my_string" class.<br/>

<h3>Step 1 - modifying "my_string"</h3>
"my_string" needs to be modified to use the template class, this involves making it considerably simpler that previously needed as much of the functionality is now covered by the "temp_ref" class. The class still needs basic methods included and I've experimented with handling exception errors, something that proved surplus to requirements for the task at hand.<br/>
![my_string](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_string.png "my_string")<br/>
<h3>Step 2 - Applying to template/testing</h3>
The "main" function in "test_my_string" sets a string to be used then applies the template to the "my_string" class, this is quite simple as most of the legwork is already done within the template.
<br/>
![main](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_main.png "main")<br/>
When the program is ran it gives this:<br/>
![Main test](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet1/Images/task4_test.png "main test")<br/>

<br/>
This approach gives both a more robust and more flexible reference count system that can be applied to multiple classes with ease.<br/><br/>

[Worksheet 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1) | [Task 1](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%201) | [Task 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%202) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet1/Task%203)