// Task 4 uses less from the other tasks as it approches the problem from a more general approach with regards to the class system
// This file creates a template class with an inbuilt reference counter
// Can be implemented with my_string so it uses the template

// include guard to prevent multiple incl;usions of header, alt pragma
#ifndef TEMP_REF_HPP
#define TEMP_REF_HPP

#include <iostream>
#include <cstring>
#include <stdexcept>

// generic temp_ref class with reference counter
template <typename temp>
class temp_ref {
private:
    //pointers
    temp* obj;
    int* r_count;


    // release decrements reference count and deletes resource at count == 0
    void release(){
        if (r_count){
            (*r_count)--;
            if (*r_count ==0){
                std::cout << "Release Memory: " << obj << std::endl;
                delete obj;
                delete r_count;
            }
        }
    }

public:
    //constructors
    temp_ref(temp* newObj) : obj(newObj), r_count(new int(1)){}

    temp_ref(const temp_ref<temp>& other) : obj(other.obj), r_count(other.r_count){
        (*r_count)++;

    }

    //assignment operator
    temp_ref& operator=(const temp_ref<temp>& other){
        if (this != &other){
            release();
            obj = other.obj;
            r_count = other.r_count;
            (*r_count)++;
        }
        return *this;
    }

    // Destructor
    ~temp_ref(){
        release();
    }

    // access object
    temp* operator->() const {
        return obj;
    }

    // Dereference
    temp* operator*() const {
        return *obj;
    }

    // Get reference counter
    int getr_count() const {
        return *r_count;
    }

};

#endif