<h1>Task 1</h1>
[Worksheet 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet2) | [Task 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet2/Task%202) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet2/Task%203) <br/>

Task 1 required the construction of a bump allocator. This is a basic design and as such has many limitations such as only being able to free all memory at once. To create the allocator several key aspects are needed. As many smaller aspects of the design were covered in worksheet 1, the write up here will focus on overall design decisions and aspects not touched upon in worksheet 1.

<h3>Step 1 - Class design</h3>

In this case the class design is relatively simple as the class only neeeds a handfull of attributes and methods. The attributes needed govern the start point and size of the heap, as well as the "next" pointer and the allocator count. The methods are almost as simple with standard destructor and constructor, with the allocator and deallocator being slightly more involved. The header file has been used to declare the attributes and methods while the methods have been defined within the allocator.cpp file. This follows convention and makes the code more parseable.<br/>
Allocator.hpp:<br/>
![Allocator.hpp](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_bAllocator_class.png "Allocator.hpp")<br/>
Allocator.cpp:<br/>
![Allocator.cpp](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_bAllocator_define.png "Allocator.cpp")<br/>

<h3>Step 2 - Allocator</h3>
The allocator is in a template file in order to ensure type-safe allocations. It works through a couple of simple step; calculating memory needed, checking that there is enough memory, allocating the memory and incrementing the allocater counter.<br/>
Allocator:<br/>
![Allocator.tpp](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_allocator_tpp.png "Allocator.hpp")<br/>

<h3>Step 3 - Testing</h3>
There were several test needed to demonstrate certain functionality within the allocator. These were implemented within a basic user interface so that when ran the functionality could be chosen. It was implemented like this to ease testing and make the results more visually coherent. The code has not been proofed against incorrect user entry as it only serves as an example of functionality rather than as a program aimed to be used regularly.<br/>
![While Loop](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_main_while.png "While loop")<br/>
![While terminal](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_main_while_terminal.png "While terminal")<br/>


<h5>Example 1 - Integer allocation</h5>
Integer allocation is one of the simplest functionalities of an allocater. <br/>
Code:<br/>
![Integer test](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_test1.png "Integer results")<br/>
This gives the results below when ran:<br/>
![Integer result](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_result1.png "Integer result")<br/>

<h5>Example 2 - Double allocation</h5>
Double allocation shows that the allocater can handle multiple data types.<br/>
Code:<br/>
![Double test](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_test2.png "Double test")<br/>
This gives the results below when ran:<br/>
![Double result](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_result2.png "Double result")<br/>

<h5>Example 3 - Forced allocation error</h5>
The allocater should return "nullptr" when failing.<br/>
Code: <br/>
![Fail test](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_test3.png "Fail test")<br/>
This gives the results below when ranL<br/>
![Fail result](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_result3.png "Fail result")<br/>

<h5>Example 4 - Allocator resets</h5>
The allocater should reset when deallocation matches the number of successfull allocations.<br/>
Code: <br/>
![Reset test](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_test4.png "Reset test")<br/>
The deallocator is called twice, first to deallocate all objects, then to reset itself.<br/>
![Reset result](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/raw/main/Worksheets/Worksheet2/images/task1_result4.png "Reset result")<br/>



[Worksheet 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet2) | [Task 2](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet2/Task%202) | [Task 3](https://gitlab.uwe.ac.uk/j2-mcdaid/advanced-systems-programming/-/tree/main/Worksheets/Worksheet2/Task%203) <br/>


