
#include "allocator.hpp"

#include <cstdlib>
#include <new>

// Define constructtor for memory allocation
bAllocator::bAllocator(size_t size) : heap_size(size), a_count(0){
    // allocate memory
    heap_start = std::malloc(size);
    // checks start and throws exception if failed
    if (!heap_start) throw std::bad_alloc();

    next = heap_start;
}

// Define destructor to be able to free allocated memory
bAllocator::~bAllocator(){
    std::free(heap_start);
}

// Define dealloc method to manage tracking and reset
void bAllocator::dealloc(){
    if (0 < a_count){
        a_count--;
        if (0 == a_count){
            next = heap_start;
        }
    }
}