
#ifndef ALLOCATOR_HPP
#define ALLOCATOR_HPP


#include <cstddef> // gives size_t for representing size in bytes

class bAllocator{ // originally allocator but causes confusion
private: // define pointers and allocate variables
    void* heap_start;
    void* next;
    size_t heap_size;
    size_t a_count;

public:
    
    // constructor for fixed heap size using template
    explicit bAllocator(size_t size);

    // declare destructor for cpp implementation
    ~bAllocator();

    // Allocates memory for count objects using template
    template <typename T>
    T* alloc(size_t count);

    // declare deallocator for cpp implementation
    void dealloc();
};

#include "allocator.tpp"

#endif