
#include "allocator.hpp"

#include <iostream>

int main(){

    // User input for heap size.
    int sizeHeap;
    std::cout << "Please enter size of heap required (1024 reccomended): ";
    std::cin >> sizeHeap;
    // Creates the allocator with user input size
    bAllocator allocator(sizeHeap);

    // User input for test selection
    int testType;
    testType = 6;
    
    

    // While loop runs untill exit, running each test as selected
    while (testType != 5){
        std::cout << "---------------------------" << std::endl;
        std::cout << "Options available: " << std::endl;
        std::cout << "1. Allocate an integer." << std::endl;
        std::cout << "2. Allocate a double." << std::endl;
        std::cout << "3. Force allocation error. " << std::endl;
        std::cout << "4. Force heap reset." << std::endl;
        std::cout << "5. Exit." << std::endl;
        std::cout << "Please enter your choice here: ";
        std::cin >> testType;

        // test 1 for allocating an integer
        if (testType == 1){
            int selection;
            std::cout << "Please enter integer value: ";
            std::cin >> selection;
            int* a = allocator.alloc<int>(selection);            
            if (a){
                std::cout << "Integer allocated" << std::endl;
            }
            else{
                std::cout << "Insufficient memory for allocation." << std::endl;
            }
            testType = 0;
        }

        // test 2 for allocating a double
        if (testType == 2){

            double selection;
            std::cout << "Please enter double value: ";
            std::cin >> selection;
            double* a = allocator.alloc<double>(selection);            
            if (a){
                std::cout << "Integer allocated" << std::endl;
            }
            else{
                std::cout << "Insufficient memory for allocation." << std::endl;
            }
            testType = 0;            
        }

        // test 3 for forced allocation failure due to insufficient memory
        if (testType == 3){
            char* text = allocator.alloc<char>(2000);
            if (!text){
                std::cout << "Insufficient memory for allocation." << std::endl;
            }
            testType = 0;
        }

        if (testType == 4){
            allocator.dealloc();
            allocator.dealloc();
            std::cout << "Deallocations made and heap reset." << std::endl;
            testType = 0;           
        }
    }

    return 0;
}