
#ifndef DOWNBUMP_HPP
#define DOWNBUMP_HPP

#include <cstddef>
#include <iostream>
#include <stdexcept>

// This allocator starts at the top of the heap and bumps down
class downBump{
private:
    char* current;
    char* heap_start;
    std::size_t heap_size;

public:
    // constructor
    explicit downBump(std::size_t size) : heap_size(size){
        heap_start = new char[size];
        current = heap_start + size;
    }

    // destructor
    ~downBump(){
        delete[] heap_start;
    }

    // template for memory management, checks that there is space for pointer to bump down
    template <typename T>
    T* alloc(std::size_t count = 1){
        std::size_t total_size = count * sizeof(T);
        if(current - total_size < heap_start){
            throw std::bad_alloc();
        }
        current -= total_size;
        return reinterpret_cast<T*>(calloc);
    }

    // reset pointer to top of heap
    void reset(){
        current = heap_start + heap_size;

    }
};


#endif